/* Created with BaCon 4.5 - (c) Peter van Eerten - MIT License */
char *ERR__b2c__string_var (int nr)
{
	static char *buf[__b2c_STRING_FUNC] = { NULL };
	static int idx = 0;
	long flen = 0, slen = 0;
	char *first = NULL, *second = NULL;

	switch (nr)
	{
		case 0:
			first = "Success";
			break;
		case 1:
			first = "Trying to access illegal memory: ";
			second = strerror (errno);
			break;
		case 2:
			first = "Error opening file: ";
			second = strerror (errno);
			break;
		case 3:
			first = "Could not open library.";
			break;
		case 4:
			first = "Symbol not found in library.";
			break;
		case 5:
			first = "Wrong value: ";
			second = strerror (errno);
			break;
		case 6:
			first = "Unable to claim memory.";
			break;
		case 7:
			first = "Unable to delete file: ";
			second = strerror (errno);
			break;
		case 8:
			first = "Could not open directory: ";
			second = strerror (errno);
			break;
		case 9:
			first = "Unable to rename file: ";
			second = strerror (errno);
			break;
		case 10:
			first = "NETWORK argument should contain colon with port number";
			break;
		case 11:
			first = "Could not resolve hostname!";
			break;
		case 12:
			first = "Socket error: ";
			second = strerror (errno);
			break;
		case 13:
			first = "Unable to open address: ";
			second = strerror (errno);
			break;
		case 14:
			first = "Error reading from socket: ";
			second = strerror (errno);
			break;
		case 15:
			first = "Error sending to socket: ";
			second = strerror (errno);
			break;
		case 16:
			first = "Error checking socket: ";
			second = strerror (errno);
			break;
		case 17:
			first = "Unable to bind the specified socket address: ";
			second = strerror (errno);
			break;
		case 18:
			first = "Unable to listen to socket address: ";
			second = strerror (errno);
			break;
		case 19:
			first = "Cannot accept incoming connection: ";
			second = strerror (errno);
			break;
		case 20:
			first = "Unable to remove directory: ";
			second = strerror (errno);
			break;
		case 21:
			first = "Unable to create directory: ";
			second = strerror (errno);
			break;
		case 22:
			first = "Unable to change to directory: ";
			second = strerror (errno);
			break;
		case 23:
			first = "GETENVIRON argument does not exist as environment variable";
			break;
		case 24:
			first = "Unable to stat file: ";
			second = strerror (errno);
			break;
		case 25:
			first = "Search contains illegal string";
			break;
		case 26:
			first = "Cannot return name: ";
			second = strerror (errno);
			break;
		case 27:
			first = "Illegal regex expression";
			break;
		case 28:
			first = "Unable to create bidirectional pipes: ";
			second = strerror (errno);
			break;
		case 29:
			first = "Unable to fork process: ";
			second = strerror (errno);
			break;
		case 30:
			first = "Cannot read from pipe: ";
			second = strerror (errno);
			break;
		case 31:
			first = "Gosub nesting too deep!";
			break;
		case 32:
			first = "Could not open device: ";
			second = strerror (errno);
			break;
		case 33:
			first = "Error configuring serial port: ";
			second = strerror (errno);
			break;
		case 34:
			first = "Error accessing device: ";
			second = strerror (errno);
			break;
		case 35:
			first = "Error in INPUT: ";
			second = strerror (errno);
			break;
		case 36:
			first = "Illegal value in SORT dimension!";
			break;
		case 37:
			first = "Illegal option for SEARCH!";
			break;
		case 38:
			first = "Invalid UTF8 string!";
			break;
		case 39:
			first = "Illegal EVAL expression!";
			break;
		case 40:
			first = "SSL file descriptor error!";
			break;
		case 41:
			first = "Error loading certificate!";
			break;
		case 42:
			first = "Widget not found!";
			ERROR = 42;
			break;
		case 43:
			first = "Unsupported array type!";
			break;
	};
	if (first)
	{
		flen = strlen (first);
	}
	if (second)
	{
		slen = strlen (second);
	}
	idx++;
	if (idx == __b2c_STRING_FUNC)
	{
		idx = 0;
	}
	buf[idx] = (char *) __b2c_str_realloc (buf[idx], flen + slen + 1);
	if (first)
	{
		memmove (buf[idx], first, flen);
	}
	if (second)
	{
		memmove (buf[idx] + flen, second, slen);
	}
	__b2c__SETLEN (buf[idx], flen + slen);
	buf[idx][flen + slen] = '\0';
	return ((char *) buf[idx]);
}

char *__b2c__strdup (const char *s)
{
	if (s == NULL)
	{
		return (NULL);
	}
	return (strdup (s));
}

char *__b2c__strndup (const char *s, size_t n)
{
	char *cnew;

	if (s == NULL)
	{
		return (NULL);
	}
	cnew = (char *) malloc (n + 1);
	if (cnew == NULL)
		return (NULL);
	cnew[n] = '\0';
	return (char *) strncpy (cnew, s, n);
}

int __b2c__strcmp (const char *__b2c__s1, const char *__b2c__s2)
{
	if (__b2c__s1 == NULL && __b2c__s2 == NULL)
		return (0);
	if (__b2c__s1 == NULL)
	{
		__b2c__s1 = EmptyString;
	}
	if (__b2c__s2 == NULL)
	{
		__b2c__s2 = EmptyString;
	}
	return (strcmp (__b2c__s1, __b2c__s2));
}

int __b2c__strcasecmp (const char *__b2c__s1, const char *__b2c__s2)
{
	if (__b2c__s1 == NULL && __b2c__s2 == NULL)
	{
		return (0);
	}
	if (__b2c__s1 == NULL)
	{
		return (-1);
	}
	if (__b2c__s2 == NULL)
	{
		return (1);
	}
	return (strcasecmp (__b2c__s1, __b2c__s2));
}

void *__b2c_str_realloc (char *ptr, size_t size)
{
	if (ptr == NULL || (((uintptr_t) ptr & 1) && __b2c__INRANGE (ptr) ? *(uint32_t *) (ptr - __b2c__BUFOFFSET + 4) : 0) <= size)
	{
		if ((uintptr_t) ptr & 1)
		{
			ptr = (char *) realloc (ptr - __b2c__BUFOFFSET, __b2c__BUFOFFSET + size * 2 + 1);
		}
		else
		{
			ptr = (char *) realloc (ptr, __b2c__BUFOFFSET + size * 2 + 1);
		} *(uint32_t *) ((char *) ptr + 4) = size * 2 + 1;
		__b2c__SETRANGE (ptr);
		ptr += __b2c__BUFOFFSET;
	}
	return (ptr);
}

char *__b2c_Copy_String (char *x, char *y)
{
	long ylen;

	if (y == NULL)
	{
		__b2c__STRFREE (x);
		return (NULL);
	}
	ylen = __b2c__len (y);
	x = (char *) __b2c_str_realloc (x, ylen);
	memmove (x, y, ylen);
	if ((uintptr_t) x & 1)
	{
		__b2c__SETLEN (x, ylen);
	}
	x[ylen] = '\0';
	return (x);
}

void __b2c_Swap_String (char **x, char **y)
{
	if (__b2c__INRANGE (*x) && __b2c__INRANGE (*y))
	{
		char *ptr;

		ptr = *x;
		*x = *y;
		*y = ptr;
	}
	else
	{
		*x = __b2c_Copy_String (*x, *y);
	}
}

unsigned long __b2c__len (const char *ptr)
{
	if (ptr == NULL)
	{
		return (0);
	}
	if (((uintptr_t) ptr & 1) && __b2c__INRANGE (ptr))
	{
		return (*(uint32_t *) (ptr - __b2c__BUFOFFSET));
	}
	return ((unsigned long) strlen (ptr));
}

char *__b2c__loop_helper (jmp_buf buf)
{
	if (__b2c__loop_result__b2c__string_var != NULL)
	{
		__b2c__SETLEN (__b2c__loop_result__b2c__string_var, 0);
		__b2c__loop_result__b2c__string_var = __b2c_Copy_String (__b2c__loop_result__b2c__string_var, EmptyString);
	}
	longjmp (buf, 1);
	return (NULL);
}

long __b2c__loop_helper2 (jmp_buf buf)
{
	__b2c__loop_result = 0;
	longjmp (buf, 1);
	return (0);
}

void __b2c__free_str_array_members (char ***array, int base, int size)
{
	int i;

	if (*array != NULL)
	{
		for (i = 0; i < size; i++)
		{
			__b2c__STRFREE ((*array)[i + base]);
			(*array)[i + base] = NULL;
		}
	}
}

void __b2c__catch_signal (int sig)
{
	switch (sig)
	{
		case SIGABRT:
			fprintf (stderr,
					 "ERROR: signal ABORT received - internal error. Try to compile the program with TRAP LOCAL to find the cause.\n");
			break;
		case SIGFPE:
			fprintf (stderr, "ERROR: signal for FPE received - division by zero? Examine the calculations in the program.\n");
			break;
		case SIGSEGV:
			fprintf (stderr,
					 "ERROR: signal for SEGMENTATION FAULT received - memory invalid or array out of bounds? Try to compile the program with TRAP LOCAL to find the cause.\n");
			break;
		case SIGILL:
			fprintf (stderr,
					 "ERROR: signal for ILLEGAL INSTRUCTION received - executing the program on other hardware? Try to recompile the program from scratch.\n");
			break;
	}
	exit (sig);
}

void __b2c__segv (int sig)
{
	longjmp (__b2c__jump, 1);
}

int __b2c__memory__check (volatile char *x, int size)
{
	int i, illegal = 0;
	void (*handler) (int);

	handler = signal (SIGSEGV, __b2c__segv);
	if (!setjmp (__b2c__jump))
	{
		for (i = 0; i < size; i++)
			if (*(x + i))
				continue;
	}
	else
		illegal = 1;
	if (__b2c__trap)
		signal (SIGSEGV, __b2c__catch_signal);
	else
		signal (SIGSEGV, handler);
	return (illegal);
}

char *__b2c__min_str (char *x, char *y)
{
	if (strcmp (x, y) < 0)
	{
		return (x);
	}
	return (y);
}

char *__b2c__max_str (char *x, char *y)
{
	if (strcmp (x, y) > 0)
	{
		return (x);
	}
	return (y);
}

char *__b2c__str (double nr)
{
	static char *buf[__b2c_STRING_FUNC] = { NULL };
	static int idx = 0;
	int len;

	idx++;
	if (idx == __b2c_STRING_FUNC)
	{
		idx = 0;
	}
	buf[idx] = (char *) __b2c_str_realloc (buf[idx], 32);
	if (floor (nr) == nr)
	{
		len = snprintf (buf[idx], 32, "%ld", (long) nr);
	}
	else
	{
		len = snprintf (buf[idx], 32, "%g", (double) nr);
	} __b2c__SETLEN (buf[idx], len);
	buf[idx][len] = '\0';
	return (char *) (buf[idx]);
}

unsigned long __b2c__timer (int init)
{
	struct timeval time;
	static time_t elapsed_secs = 0;
	static int elapsed_usecs = 0;

	if (init)
	{
		gettimeofday (&time, NULL);
		elapsed_usecs = time.tv_usec;
		elapsed_secs = time.tv_sec;
		return (0);
	}
	else
	{
		gettimeofday (&time, NULL);
		if (difftime (time.tv_sec, elapsed_secs) < 1)
		{
			return ((unsigned long) (time.tv_usec - elapsed_usecs) / 1000);
		}
		else
		{
			return ((unsigned long) (difftime (time.tv_sec, elapsed_secs) - 1) * 1000 + ((1000000 - elapsed_usecs) + time.tv_usec) / 1000);
}}}

void __b2c__argument (char **arg, int total, char **data)
{
	long x, dlen, slen, pos, tot_len = 0;
	char quote[] = { 34, 0 };
	if (total == 0)
	{
		*arg = NULL;
	}
	else
	{
		dlen = __b2c__len (__b2c__option_delim);
		for (pos = 0; pos < total; pos++)
		{
			slen = strlen (data[pos]);
			*arg = (char *) realloc (*arg, tot_len + slen * 2 + dlen + 1);
			if (strstr (data[pos], " ") || strstr (data[pos], "\""))
			{
				(*arg)[tot_len++] = 34;
				for (x = 0; data[pos][x] != 0; x++)
				{
					if (data[pos][x] == quote[0])
					{
						(*arg)[tot_len++] = __b2c__option_esc;
					}
					(*arg)[tot_len++] = data[pos][x];
				}
				(*arg)[tot_len++] = 34;
			}
			else
			{
				memmove (*arg + tot_len, data[pos], slen);
				tot_len += slen;
			}
			if (pos < total - 1)
			{
				memmove (*arg + tot_len, __b2c__option_delim, dlen);
				tot_len += dlen;
			}
		}
		*(*arg + tot_len) = '\0';
	}
}

int __b2c_utf8_conv (int txt, char *utf8)
{
	unsigned char b1, b2, b3;
	int len;

	if (txt > 0xFFFF)
	{
		b1 = txt & 0x0000FF;
		b2 = (txt & 0x00FF00) >> 8;
		b3 = (txt & 0xFF0000) >> 16;
		len =
			snprintf (utf8, 5, "%c%c%c%c", 0xF0 | (b3 >> 2), 0x80 | ((b3 & 0x03) << 4) | ((b2 & 0xF0) >> 4),
					  0x80 | ((b2 & 0x0F) << 2) | ((b1 & 0xC0) >> 6), 0x80 | (b1 & 0x3F));
	}
	else if (txt > 0x07FF)
	{
		b1 = txt & 0x00FF;
		b2 = (txt & 0xFF00) >> 8;
		len = snprintf (utf8, 4, "%c%c%c", 0xE0 | ((b2 & 0xF0) >> 4), 0x80 | ((b2 & 0x0F) << 2) | ((b1 & 0xC0) >> 6), 0x80 | (b1 & 0x3F));
	}
	else if (txt > 0x007F)
	{
		b1 = txt & 0x00FF;
		b2 = (txt & 0xFF00) >> 8;
		len = snprintf (utf8, 3, "%c%c", 0xC0 | (b2 << 2) | ((b1 & 0xC0) >> 6), 0x80 | (b1 & 0x3F));
	}
	else
	{
		len = snprintf (utf8, 2, "%c", txt & 0x7F);
	}
	return (len);
}

unsigned long __b2c__ulen (int l, char *k, char *func, char *ptr, int pos)
{
	long len = 0;

	if (ptr == NULL)
	{
		return (0);
	}
	if (pos < 0)
	{
		while (*ptr)
		{
			if ((*ptr & 0xF0) == 0xF0)
			{
				len++;
				ptr += 4;
			}
			else if ((*ptr & 0xE0) == 0xE0)
			{
				len++;
				ptr += 3;
			}
			else if ((*ptr & 0xC0) == 0xC0)
			{
				len++;
				ptr += 2;
			}
			else if ((*ptr & 0x80) == 0)
			{
				len++;
				ptr++;
			}
			else
			{
				ERROR = 38;
				RUNTIMEFERR (func, ERROR, k, l);
			}
		}
	}
	else
	{
		len = __b2c__ucs2_clen (l, k, "ULEN", ptr, pos);
	}
	return (len);
}

unsigned long __b2c__blen (int l, char *k, char *func, char *ptr, long c, int flag)
{
	char *org = ptr;

	if (ptr == NULL)
	{
		return (0);
	}
	if (flag)
	{
		c = __b2c__ulen (l, k, "BYTELEN", org, -1) - c;
	}
	while (*ptr && c > 0)
	{
		if ((*ptr & 0xF0) == 0xF0)
		{
			ptr += 4;
		}
		else if ((*ptr & 0xE0) == 0xE0)
		{
			ptr += 3;
		}
		else if ((*ptr & 0xC0) == 0xC0)
		{
			ptr += 2;
		}
		else if ((*ptr & 0x80) == 0)
		{
			ptr++;
		}
		else
		{
			ERROR = 38;
			fprintf (stderr, "Cannot decode UTF-8 string: '%s'\n", org);
			RUNTIMEFERR (func, ERROR, k, l);
		}
		c--;
	}
	if (flag)
	{
		return (__b2c__len (org) - (ptr - org));
	}
	else
	{
		return (ptr - org);
	}
}

unsigned long __b2c__ucs2_clen (int l, char *k, char *func, char *ptr, int c)
{
	int len = 0;
	char *org;

	if (ptr == NULL)
		return (0);
	org = ptr;
	while (*ptr && c > 0)
	{
		if ((*ptr & 0xF0) == 0xF0)
		{
			ptr += 4;
			c -= 4;
		}
		else if ((*ptr & 0xE0) == 0xE0)
		{
			ptr += 3;
			c -= 3;
		}
		else if ((*ptr & 0xC0) == 0xC0)
		{
			ptr += 2;
			c -= 2;
		}
		else if ((*ptr & 0x80) == 0)
		{
			ptr++;
			c--;
		}
		else
		{
			ERROR = 38;
			fprintf (stderr, "Cannot decode UTF-8 string: '%s'\n", org);
			RUNTIMEFERR (func, ERROR, k, l);
		}
		len++;
	}
	return (len);
}
